# This gives a set of objects that can be used to build levels

class _statsobject(object):
  def __get__(self):
    return self.__dict__.__get__()
  def __str__(self):
    return self.__dict__.__str__()
  def __repr__(self):
    return self.__dict__.__repr__()
  def copy(self):
    return self.__init__(self)
  def __getattr__(self,k):
    return None
  def __init__(self,old=None):
    if old:
      self.__dict__ = old.__dict__.copy()
    else: self.__dict__ = {}
class _flagobject(object):
  def __call__(self, flag):
    if type(flag) == type(int) and flag&self._value:
      return True
    if type(flag) == type(self) and flag._value&self._value:
      return True
    return False
  def __get__(self):
    return self._value.__get__()
  def __str__(self):
    return hex(self._value)
  def __repr__(self):
    return repr(hex(self._value))
  def __init__(self,flag):
    if flag == 0:
      self._value = 0
    else:
      self._value = 2**(flag-1)
class _objectMarker(object):
  @property
  def stats(self):
    return self._stats
  @property
  def flag(self):
    return self._flag
  @property
  def image(self):
    return self._image
  def __get__(self):
    return self._flag.__get__()
  def __str__(self):
    return self._flag.__str__()
  def __repr__(self):
    return self._flag.__repr__()
  def __nonzero__(self):
    return self._flag.__nonzero__()
  def __cmp__(self, other):
    return self._flag.__cmp__(other)
  def __init__(self,flag,image='',**kwargs):
    self.__dict__['_flag'] = _flagobject(flag)
    self.__dict__['_stats'] = _statsobject()
    self.__dict__['_stats'].__dict__ = kwargs
    self.__dict__['_image'] = image
  def __setattr__(self,k,v):
    try:
      assert k in self.__dict__
      self.__dict__[k] = v
    except AssertionError:
      raise AttributeError, "'%s' is not an attribute of class '%s'"%(k,self.__class__.__name__)


Out      = _objectMarker(0)

Floor    = _objectMarker(1,  'GenericCarpet')
Wall     = _objectMarker(2,  'GenericWall')
Door     = _objectMarker(3)

Player   = _objectMarker(4,  'GenericCharacter')
#Friend   = _objectMarker(5)
#Neutral  = _objectMarker(6)
#Enemy    = _objectMarker(7)

#Book     = _objectMarker(8)
#Scroll   = _objectMarker(9)
#HPotion  = _objectMarker(10)
#MPotion  = _objectMarker(11)

#Box      = _objectMarker(12)
#Resource = _objectMarker(13)

#Dagger   = _objectMarker(14)
#Bow      = _objectMarker(15)
#Axe      = _objectMarker(16)
Shield   = _objectMarker(17)
Sword    = _objectMarker(18,  'GenericWeapon')
