from PyQt4.Qt import (QWidget,
                      QColor,
                      QPainter,
                      QBrush,
                      pyqtSignal,
                      QRect)

from PyQt4.QtCore import Qt

class DisplayWindow(QWidget):
  pressed = pyqtSignal(tuple)
  released = pyqtSignal(tuple)
  clicked = pyqtSignal(tuple)
  dragged = pyqtSignal(tuple)
  def giveTile(self,x,y):
    x += self.x_offset
    y += self.y_offset
    tsx,tsy = self.tilesize
    X = x/tsx - 1  + ((x % tsx) != 0)
    Y = y/tsy - 1 + ((y % tsy) != 0)
    return X,Y
  def mousePressEvent(self, event):
    if event.button() == Qt.LeftButton:
      pos = self.giveTile(event.x(),event.y())
      self.pressed.emit(pos)
      self._TouchStarted = pos
  def mouseReleaseEvent(self, event):
    if event.button() == Qt.LeftButton:
      x,y = self.giveTile(event.x(),event.y())
      self.released.emit((x,y))
      X,Y = self._TouchStarted
      if (x,y) == (X,Y):
        self.clicked.emit((x,y))
      else:
        self.dragged.emit((X-x,Y-y))
      self._TouchStarted = None
  def __init__(self, player, textstream, **kwargs):
    QWidget.__init__(self)
    self.qp = QPainter()
    self.textstream = textstream
    self._TouchStarted = None
    self.displayQueue = []
    self.x_offset = 0
    self.y_offset = 0
    self.tilesize = (40,40)
    self.player = player
  def resizeEvent(self, event):
    rect = self.rect()
    self.textstream.append( 'Display window:\t' + `rect.width()` + "x" + `rect.height()`)
  def _showtile(self, tile, event):
    from _clickableIcon import clickableIcon
    for subtile in tile.contents:
      self._showTile(subtile, event)
    if tile.image:
      image = clickableIcon(self, tile.image)
      x,y = tile.position
      X,Y = self.tilesize
      image.setRect(x*X, y*Y, X, Y)
      image.paintEvent(event)
  def paintEvent(self, event):
    self.qp = QPainter()
    c = (QColor("#121"),
         QColor("#101"))
    brush = QBrush(Qt.SolidPattern)
    rect = self.rect()
    self.qp.begin(self)
    self.qp.setBrush(brush)
    currlevel = self.player.container
    currworld = currlevel.container
    otherlevels = (    level
                   for level
                   in  currworld.contents
                   if  type(level) == type(currlevel)
                   and level != currlevel)
    for tile in currlevel.contents:
      self._showtile(tile, event)
    self.qp.end()
    QWidget.paintEvent(self, event)
    self.textstream.append("Drawing")