from PyQt4.QtGui import (QGridLayout,
                         QWidget,
                         QColor,
                         QPainter,
                         QBrush)

from PyQt4.QtCore import Qt
import os.path
class Interface(QWidget):
  def toggleFullscreen(self):
    p = self.parent
    if p.isFullScreen():
      p.setWindowState(Qt.WindowNoState)
    else:
      p.setWindowState(Qt.WindowFullScreen)
  def move_up(self):
    self.player.commands.add(self.player,'up')
  def move_down(self):
    self.player.commands.add(self.player,'down')
  def move_left(self):
    self.player.commands.add(self.player,'left')
  def move_right(self):
    self.player.commands.add(self.player,'right')
  def set_attack(self,bool_in):
    self.attackmode = bool_in
  def set_move(self,bool_in):
    self.movemode = bool_in
  def handleDisplayDragged(self, pos):
    self.textstream.append('screen dragged by: '+`pos`)
  def handleDisplayClicked(self, pos):
    if self.attackmode:
      self.player.commands.add(self.player,'attack',pos)
      self.B_ATTK.toggle()
    elif self.movemode:
      self.player.commands.add(self.player,'move',pos)
      self.B_MOVE.toggle()
    else:
      self.textstream.append('screen clicked at: '+`pos`)

  def __init__(self, player, parent, textstream, **kwargs):
    QWidget.__init__(self)

    def mkbutton(y,x,h=1,w=1,image=None,act=None,toggle=False):
      from _interfaceButton import interfaceButton
      if image:
        b = interfaceButton(self, "_Display/Buttons/"+image+".png")
      else:
        b = interfaceButton(self)
      self.OptionsGrid.addWidget(b,y,x,h,w)
      if act:
        if toggle:
          b.setCheckable(True)
          b.toggled.connect(act)
        else:
          b.clicked.connect(act)
      return b

    self.qp = QPainter()
    self.OptionsGrid = QGridLayout(self)
    self.parent = parent
    self.player = player
    self.textstream = textstream
    self.height = 32
    self.margin = 4
    self.spacing = 8
    self.attackmode = False
    self.movemode = False

    self.OptionsGrid.setMargin(self.margin)
    self.OptionsGrid.setSpacing(self.spacing)

    self.parent.MainGraphicView.clicked.connect(self.handleDisplayClicked)
    self.parent.MainGraphicView.dragged.connect(self.handleDisplayDragged)

    if True: #Spawn buttons
      self.B_ATTK = mkbutton(0,0,1,1,"Attack",  self.set_attack,True)
      self.B_MVUP = mkbutton(0,1,1,1,"up",      self.move_up)
      self.B_MOVE = mkbutton(0,2,1,1,"Move",    self.set_move,True)
      self.B_0__3 = mkbutton(0,3)
      self.B_0__4 = mkbutton(0,4)
      self.B_0__5 = mkbutton(0,5)
      self.B_0__6 = mkbutton(0,6)
      self.B_0__7 = mkbutton(0,7)
      self.B_MVLT = mkbutton(1,0,1,1,"left",    self.move_left)
      self.B_MVDN = mkbutton(1,1,1,1,"down",    self.move_down)
      self.B_MVRT = mkbutton(1,2,1,1,"right",   self.move_right)
      self.B_1__3 = mkbutton(1,3)
      self.B_1__4 = mkbutton(1,4)
      self.B_1__5 = mkbutton(1,5)
      self.B_1__6 = mkbutton(1,6)
      self.B_1__7 = mkbutton(1,7)
      self.B_QUIT = mkbutton(0,12,2,2,"close",  self.parent.close)
      self.B_FULL = mkbutton(0,14,2,2,"fullscr",self.toggleFullscreen)
    self.rowcount = self.OptionsGrid.rowCount()
    self.setFixedHeight(self.height*self.rowcount +
                        self.margin*2 +
                        self.spacing*(self.rowcount-1))
  def resizeEvent(self, event):
    rect = self.rect()
    self.textstream.append( 'Interface:\t\t' +
                            `rect.width()` +
                            "x" +
                            `rect.height()`)
  def paintEvent(self, event):
    #print "Painting options"
    charcoal = QColor("#101010")
    black = QColor("#000000")
    brush = QBrush(Qt.SolidPattern)
    rect = self.rect()
    self.qp.begin(self)
    self.qp.setBrush(brush)
    self.qp.fillRect(rect, charcoal)
    self.qp.end()

