#!/usr/bin/python
#
from GameObjects import GameObject, World, Level, Weapon, Character, Containable
from Display import DisplayObject
from Levels import worlds
from Levels import objects
def setupTile(x, y, tile, thisLevel, Game):
  cont = thisLevel
  if tile.flag != objects.Out.flag:
    if tile.flag(objects.Floor.flag):# This needs to not be collision-tested
      Containable(flag=tile.flag, container=cont, position=(x,y), name="Floor@%s"%(`(x,y)`), image=tile.image)
    if tile.flag(objects.Wall.flag): # This needs to be indestructable
      Containable(flag=tile.flag, container=cont, position=(x,y), name="Wall@%s"%(`(x,y)`), image=tile.image)
    if tile.flag(objects.Door.flag): # This needs to link levels
      Containable(flag=tile.flag, container=cont, position=(x,y), name="Door@%s"%(`(x,y)`), image=tile.image)
    if tile.flag(objects.Player.flag):
      Game.Player = Character(flag=tile.flag, container=cont, position=(x,y), name="Player 1", image=tile.image)
    # if tile.flag(objects.Box.flag):     # Not implemented yet
      # print "Adding a box","at %s"%(`(x,y)`)
    # if tile.flag(objects.Resource.flag):# Not implemented yet
      # print "Adding a resource stash","at %s"%(`(x,y)`)
    # if tile.flag(objects.Friend.flag):  # Not implemented yet
      # print "Adding a friend","at %s"%(`(x,y)`)
    # if tile.flag(objects.Enemy.flag):   # Not implemented yet
      # print "Adding an enemy","at %s"%(`(x,y)`)
    # if tile.flag(objects.Neutral.flag): # Not implemented yet
      # print "Adding a neutral party","at %s"%(`(x,y)`)
    # if tile.flag(objects.Book.flag):    # Not implemented yet
      # print "Adding a book","at %s"%(`(x,y)`)
    # if tile.flag(objects.Scroll.flag):  # Not implemented yet
      # print "Adding a scroll","at %s"%(`(x,y)`)
    # if tile.flag(objects.HPotion.flag): # Not implemented yet
      # print "Adding a health potion","at %s"%(`(x,y)`)
    # if tile.flag(objects.MPotion.flag): # Not implemented yet
      # print "Adding a mana potion","at %s"%(`(x,y)`)
    # if tile.flag(objects.Dagger.flag):  # Not implemented yet
      # print "Adding a dagger","at %s"%(`(x,y)`)
    # if tile.flag(objects.Bow.flag):     # Not implemented yet
      # print "Adding a bow","at %s"%(`(x,y)`)
    # if tile.flag(objects.Axe.flag):     # Not implemented yet
      # print "Adding an axe","at %s"%(`(x,y)`)
    if tile.flag(objects.Shield.flag):
      Weapon(flag=tile.flag, container=cont, position=(x,y), name="Sheild@%s"%(`(x,y)`), image=tile.image)
    if tile.flag(objects.Sword.flag):
      Weapon(flag=tile.flag, container=cont, position=(x,y), name="Sword@%s"%(`(x,y)`), image=tile.image)
  return cont


def setupGame():
  Game = GameObject(flag=objects.Out.flag, name="Game")
  DisplayList = []
  
  wn = 0
  for world in worlds:
    thisWorld = World(flag=objects.Out.flag, container=Game, name="World_%s"%(`wn`))
    ln = 0
    for level in world:
      thisLevel = Level(flag=objects.Out.flag, container=thisWorld, name="Level_%s.%s"%(`wn`,`ln`))
      x,y = 0,0
      for line in level:
        for tile in line:
          if type(tile) == type(tuple()):
            cont = thisLevel
            for item in tile:
              cont = setupTile(x, y, item, cont, Game)
          else:
            setupTile(x, y, tile, thisLevel, Game)
          x += 1
        x =  0
        y += 1
    wn += 1
  return Game
if __name__ == "__main__":
  Game = setupGame()
  d = DisplayObject(Game)
  d.exec_()
